# -*- coding: utf-8 -*-

from cliente import *
from fornecedor import *
from venda import *
from produto import *
from compra import *
from operator import itemgetter, attrgetter, methodcaller # sort
import csv
import sys
import math
import itertools # to jump header in csv
import locale # 10,20 10.20
import operator # sort

locale.setlocale(locale.LC_ALL, 'pt_BR.UTF-8')
#-p produtos.csv -f fornecedores.csv -v vendas.csv -a compras.csv --read-only -c clientes.csv
arquivo_produtos = ''
arquivo_fornecedores = ''
arquivo_vendas = ''
arquivo_compras = ''
arquivo_clientes = ''

arquivo_apagar = 'apagar.csv'
arquivo_areceber = 'areceber.csv'
arquivo_vendasprod = 'vendasprod.csv'
arquivo_vendaspgto = 'vendaspgto.csv'
arquivo_estoque = 'estoque.csv'

def main():
    tam = len(sys.argv)
    if tam < 11:
        print 'Erro de I/O'
        return

    contador = 1
    while contador < tam:
        #print sys.argv[contador]
        if sys.argv[contador] == '-p':
            arquivo_produtos = sys.argv[contador+1]
            try:
                arquivo_produtos = open(arquivo_produtos)
            except IOError as e:
                print 'Erro de I/O'
                return
        if sys.argv[contador] == '-f':
            arquivo_fornecedores = sys.argv[contador+1]
            try:
                arquivo_fornecedores = open(arquivo_fornecedores)
            except IOError as e:
                print 'Erro de I/O'
                return
        if sys.argv[contador] == '-v':
            arquivo_vendas = sys.argv[contador+1]
            try:
                arquivo_vendas = open(arquivo_vendas)
            except IOError as e:
                print 'Erro de I/O'
                return
        if sys.argv[contador] == '-a':
            arquivo_compras = sys.argv[contador+1]
            try:
                arquivo_compras = open(arquivo_compras)
            except IOError as e:
                print 'Erro de I/O'
                return
        if sys.argv[contador] == '-c':
            arquivo_clientes = sys.argv[contador+1]
            try:
                arquivo_clientes = open(arquivo_clientes)
            except IOError as e:
                print 'Erro de I/O'
                return
        contador += 1

    clientes = []
    vendas = []
    compras = []
    fornecedores = []
    produtos = []

    #print __doc__
    #cli = csv.reader(open(arquivo_clientes), delimiter=';') # Leitura de arquivo csv
    cli = csv.reader(arquivo_clientes, delimiter=';') # Leitura de arquivo csv
    csv_clientes = itertools.islice(cli, 1, None) # Pula a primeira linha
    for [codigo, nome, endereco, telefone, data_cadastro, tipo, cnpj_cpf, inscricao_estadual] in csv_clientes: #separa cada linha do csv nas variaveis dentro dos []
        # para tipos diferentes de clientes existe tipos diferentes de cadastro
        if tipo == 'J':
            clientes.append(Cliente(codigo, nome, endereco, telefone, data_cadastro, tipo, cnpj_cpf, inscricao_estadual)) # insere na lista um novo objeto do tipo Cliente

        elif tipo == 'F':
            clientes.append(Cliente(codigo, nome, endereco, telefone, data_cadastro, tipo, cnpj_cpf)) # insere na lista um novo objeto do tipo Cliente

    ven = csv.reader(arquivo_vendas, delimiter=';') # Leitura de arquivo csv
    csv_vendas = itertools.islice(ven,1,None) # Pula a primeira linha
    for [cliente,data_venda, produto, quantidade, modo_pagamento] in csv_vendas: # separa cada linha do csv nas variaveis dentro dos []
        vendas.append(Venda(cliente,data_venda,produto,quantidade,modo_pagamento)) # insere na lista um novo objeto do tipo Venda

    comp = csv.reader(arquivo_compras, delimiter=';') # Leitura de arquivo csv
    csv_compras = itertools.islice(comp,1,None) # Pula a primeira linha
    for [nota_fiscal,fornecedor,data_da_compra,produto,quantidade] in csv_compras: # separa cada linha do csv nas variaveis dentro do []
        compras.append(Compra(nota_fiscal,fornecedor,data_da_compra,produto,quantidade)) # insere na lista um novo objeto do tipo Compra

    forn = csv.reader(arquivo_fornecedores, delimiter=';') # Leitura de arquivo csv
    csv_fornecedores = itertools.islice(forn,1,None) # Pula a primeira linha
    for [codigo,nome,endereco,telefone,cnpj,pessoa_de_contato] in csv_fornecedores: # separa cada linha do csv nas variaveis dentro do []
        fornecedores.append(Fornecedor(codigo,nome,endereco,telefone,cnpj,pessoa_de_contato)) # insere na lista um novo objeto do tipo Fornecedor


    prod = csv.reader(arquivo_produtos, delimiter=';') # Leitura de arquivo csv
    csv_produtos = itertools.islice(prod,1,None) # Pula a primeira linha
    for [codigo,descricao,estoque_minimo,estoque_atual,valor_de_custo,percentual_de_lucro] in csv_produtos: # separa cada linha do csv nas variaveis dentro do []
        produtos.append(Produto(codigo,descricao,estoque_minimo,estoque_atual,locale.atof(valor_de_custo),percentual_de_lucro)) # insere na lista um novo objeto do tipo Produto


    #total a pagar por fornecedor
    with open(arquivo_apagar, 'wb') as apagar_csvfile:
        spamwriter = csv.writer(apagar_csvfile, delimiter=';')
        valor_total_a_pagar = 0
        fornecedores.sort(key=operator.attrgetter('nome'))
        for fornecedor in fornecedores: #  fornecedores[]
            for compra in compras:
                if compra.getCodigoFornecedor() == fornecedor.getCodigo():
					quantidade = int(compra.getQuantidade())
					for produto in produtos:
						if compra.getCodigoProduto() == produto.getCodigo():
							valor_total_a_pagar += quantidade*float(produto.getValorCusto())
							quantidade = 0

            spamwriter.writerow([fornecedor.getNome(), fornecedor.getCnpj(), fornecedor.getPessoaContato(), fornecedor.getTelefone(), valor_total_a_pagar])
            #print 'Fornecedor=%s | CNPJ=%s | Contato=%s | Telefone=%s | Valor a paga=%s' % (fornecedor.getNome(), fornecedor.getCnpj(), fornecedor.getPessoaContato(), fornecedor.getTelefone(), valor_total_a_pagar)
            valor_total_a_pagar = 0


    #total a receber por cliente
    with open(arquivo_areceber, 'wb') as areceber_csvfile:
        spamwriter = csv.writer(areceber_csvfile, delimiter=';')
        valor_total_a_receber_cliente = 0
        clientes.sort(key=operator.attrgetter('nome'))
        for cliente in clientes:
            for venda in vendas:
                if venda.getCliente() == cliente.getCodigo(): #se diff null entao foi fiado
                    quantidade = int(venda.getQuantidade())
                    for produto in produtos:
                        if produto.getCodigo() == venda.getProduto():
                            valor_total_a_receber_cliente += quantidade*float(produto.calculaValorVenda())
                            quantidade = 0
            #print 'Cliente=%s | Tipo Cliente=%s | CPF/CNPJ=%s | Telefone=%s | Data Cadastro=%s | Total a Pagar=%s' % (cliente.getNome(), cliente.getTipo(), cliente.getCnpjCpf(), cliente.getTelefone(), cliente.getDataCadastro(), valor_total_a_receber_cliente)
            spamwriter.writerow([cliente.getNome(), cliente.getTipo(), cliente.getCnpjCpf(), cliente.getTelefone(), cliente.getDataCadastro(), valor_total_a_receber_cliente])
            valor_total_a_receber_cliente = 0

    #vendas e lucro por produtos
    #<código do produto>;<descrição do produto>;<receita bruta da venda do produto>;<lucro da venda do produto>
    #Este relatório deve ser ordenado por lucro da venda do produto, decrescente. Em caso de empate, deve-se ordenar por código do produto.
    lucro_produto = []
    for produto in produtos:
        quantidade = 0  # inicia variavel para quantidade de produtos
        for venda in vendas:
            if venda.getProduto() == produto.getCodigo():   # verifica se o codigo do produto eh o mesmo da venda
                quantidade += int(venda.getQuantidade())    # soma a quantidade de produtos da venda
        #if quantidade > 0:  # se a quantidade for maior que 0 insere na lista o output desejado (contas ja feitas)
        lucro_produto.append((produto.getCodigo(),produto.getDescricao(), quantidade*float(produto.calculaValorVenda()), quantidade*(produto.calculaValorVenda()-produto.getValorCusto())))
    # ordena lista primeiro pelo lucro e depois pelo codigo
    lucro_produto.sort(key=itemgetter(0))
    lucro_produto.sort(key=itemgetter(3),reverse=True)

    # escreve no csv de saida
    with open(arquivo_vendasprod, 'wb') as vendasprod_csvfile:
        spamwriter = csv.writer(vendasprod_csvfile, delimiter=';')
        for x in lucro_produto:
            spamwriter.writerow([x[0],x[1],x[2],x[3]])

    # Vendas e Lucro por Forma de Pagamento

    #<modo de pagamento>;<receita bruta deste modo de pagamento>;<lucro deste modo de pagamento>
    # este relatorio tambem deve ser ordernado por lucro, decrescente. Em caso de empate, deve-se
    # ordenar pela letra que representa o modo de pagamento

    receita_dinheiro = 0
    receita_cheque = 0
    receita_debito = 0
    receita_credito = 0
    receita_ticket = 0
    receita_fiado = 0

    lucro_dinheiro = 0
    lucro_cheque = 0
    lucro_debito = 0
    lucro_credito = 0
    lucro_ticket = 0
    lucro_fiado = 0

    vendaspgto = []

    for venda in vendas:
        for produto in produtos:
            if venda.getProduto() == produto.getCodigo():
                if venda.getModoPagamento() == '$':  # dinheiro
                    receita_dinheiro += int(venda.getQuantidade())*float(produto.calculaValorVenda())
                    lucro_dinheiro += int(venda.getQuantidade())*(float(produto.calculaValorVenda())
                                                                  - float(produto.getValorCusto()))
                elif venda.getModoPagamento() == 'X':  # cheque
                    receita_cheque += int(venda.getQuantidade())*float(produto.calculaValorVenda())
                    lucro_cheque += int(venda.getQuantidade())*(float(produto.calculaValorVenda())
                                                                - float(produto.getValorCusto()))
                elif venda.getModoPagamento() == 'D':  # cartao debito
                    receita_debito += int(venda.getQuantidade())*float(produto.calculaValorVenda())
                    lucro_debito += int(venda.getQuantidade())*(float(produto.calculaValorVenda())
                                                                - float(produto.getValorCusto()))
                elif venda.getModoPagamento() == 'C':  # cartao credito
                    receita_credito += int(venda.getQuantidade())*float(produto.calculaValorVenda())
                    lucro_credito += int(venda.getQuantidade())*(float(produto.calculaValorVenda())
                                                                 - float(produto.getValorCusto()))
                elif venda.getModoPagamento() == 'T':  # ticket
                    receita_ticket += int(venda.getQuantidade())*float(produto.calculaValorVenda())
                    lucro_ticket += int(venda.getQuantidade())*(float(produto.calculaValorVenda())
                                                                - float(produto.getValorCusto()))
                elif venda.getModoPagamento() == 'F':  # fiado
                    receita_fiado += int(venda.getQuantidade())*float(produto.calculaValorVenda())
                    lucro_fiado += int(venda.getQuantidade())*(float(produto.calculaValorVenda())
                                                               - produto.getValorCusto())

    vendaspgto.append(('$', receita_dinheiro, lucro_dinheiro))
    vendaspgto.append(('X', receita_cheque, lucro_cheque))
    vendaspgto.append(('D', receita_debito, lucro_debito))
    vendaspgto.append(('C', receita_credito, lucro_credito))
    vendaspgto.append(('T', receita_ticket, lucro_ticket))
    vendaspgto.append(('F', receita_fiado, lucro_fiado))

    vendaspgto.sort(key=itemgetter(2, 0), reverse=True)

    with open(arquivo_vendaspgto, 'wb') as vendaspgto_csvfile:
        spamwriter = csv.writer(vendaspgto_csvfile, delimiter=';')
        for x in vendaspgto:
            spamwriter.writerow([x[0], x[1], x[2]])

    # Estado do Estoque

    # <codigo produto>;<descricao do produto>;<quantidade em estoque apos as vendas do mes>;<observacoes>
    # Este relatorio deve ser ordenado pela descricao do produto. No campo observacoes, deve constar o termo
    # "COMPRAR MAIS" (sem aspas) caso o produto, ao final do mes, tenha ficado com uma quantidade em estoque
    # abaixo do limite minimo para o produto

    produtos.sort(key=operator.attrgetter('descricao'))
    with open(arquivo_estoque, 'wb') as estoque_csvfile:
        spamwriter = csv.writer(estoque_csvfile, delimiter=';')
        for produto in produtos:
            quantidade = 0
            for venda in vendas:
                if venda.getProduto() == produto.getCodigo():
                    quantidade += int(venda.getQuantidade())

            #if quantidade > 0:
            estoque_apos_vendas = int(produto.getEstoqueAtual()) - quantidade
            quantidade = 0
            if estoque_apos_vendas < int(produto.getEstoqueMinimo()):
                spamwriter.writerow([produto.getCodigo(), produto.getDescricao(), estoque_apos_vendas, 'COMPRAR MAIS'])
            else:
                spamwriter.writerow([produto.getCodigo(), produto.getDescricao(), estoque_apos_vendas])

    return


main()

